<template>
    <div>
        <br>

        <div>
            <h5>Neue TeilnehmerIn hinzufügen</h5>
            <b-button id="show-btn" variant="success" @click="showModal2">

                <b-icon icon="plus-square" aria-hidden="true"></b-icon>
            </b-button>

            

            <b-modal ref="my-modal2" @hidden="resetModal1" hide-footer>
                <div class="d-block text-center">
                    <form method="post">
                        <b-container fluid>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Namen eingeben"
                                        v-model="teilnehmerInnen.name"></b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="E-Mail eingeben"
                                        v-model="teilnehmerInnen.eMail"></b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Adresse eingeben"
                                        v-model="teilnehmerInnen.adresse"></b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Telefonnummer eingeben"
                                        v-model="teilnehmerInnen.telnum"></b-form-input>
                                </b-col>
                            </b-row>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Startdatum eingeben"
                                        v-model.number="teilnehmerInnen.startdatum"></b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Enddatum eingeben"
                                        v-model.number="teilnehmerInnen.enddatum"></b-form-input>
                                </b-col>
                            </b-row>


                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Gruppe auswählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="teilnehmerInnen.gruppeId">
                                        <option v-for="gruppe in gruppen" v-bind:key="gruppe.id"
                                            :value="gruppe.gruppen_ID"> {{ gruppe.gruppenEnums }}.{{ gruppe.nummer }}
                                        </option>
                                    </select>
                                </b-col>
                            </b-row>

                        </b-container>
                        <div>
                            <b-button block variant="outline-success" @click="postTeilnehmerIn()">
                                Speichern</b-button>
                        </div>
                    </form>
                </div>
            </b-modal>
        </div>

        <div>
            <b-modal ref="my-modal3" hide-footer>
                <div class="d-block text-center">
                    <form method="post">
                        <b-container fluid>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" v-model="editTeilnehmerInnen.name">
                                    </b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" v-model="editTeilnehmerInnen.eMail">
                                    </b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" v-model="editTeilnehmerInnen.adresse">
                                    </b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" v-model="editTeilnehmerInnen.telnum">
                                    </b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" v-model="editTeilnehmerInnen.startdatum">
                                    </b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" v-model="editTeilnehmerInnen.enddatum">
                                    </b-form-input>
                                </b-col>
                            </b-row>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Gruppe auswählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="editTeilnehmerInnen.gruppeId">
                                        <option v-for="gruppe in gruppen" v-bind:key="gruppe.id"
                                            :value="gruppe.gruppen_ID"> {{ gruppe.gruppenEnums }} . {{ gruppe.nummer }}
                                        </option>
                                    </select>
                                </b-col>
                            </b-row>




                        </b-container>

                        <b-button class="mt-3" variant="outline-success" @click="putTeilnehmerIn()" block>Speichern
                        </b-button>
                    </form>
                </div>

            </b-modal>
        </div>

        <br>


        <table class="table">
            <tbody>
                <tr>
                    <!-- <th>ID</th> -->
                    <th>Name</th>
                    <th>E-Mail Adresse</th>
                    <th>Adresse</th>
                    <th>Telefonnummer</th>
                    <th>Startdatum</th>
                    <th>Enddatum</th>
                    <th></th>
                    <th></th>
                </tr>
                <tr v-for="teilnehmer in teilnehmerIn" v-bind:key="teilnehmer.id">
                    <!-- <td>{{ teilnehmer.id }}</td> -->
                    <td>{{ teilnehmer.name }}</td>
                    <td>{{ teilnehmer.eMail }}</td>
                    <td>{{ teilnehmer.adresse }}</td>
                    <td>{{ teilnehmer.telnum }}</td>
                    <td>{{ teilnehmer.startdatum }}</td>
                    <td>{{ teilnehmer.enddatum }}</td>
                    <td>
                        <b-button id="show-btn" @click="showModal3(teilnehmer.id), editTeilnehmerIn(teilnehmer)"
                            variant="primary">
                            <b-icon icon="pencil" aria-hidden="true"></b-icon>
                        </b-button>
                    </td>
                    <td>
                        <b-button @click="deleteTeilnehmerIn(teilnehmer.id)" variant="danger">
                            <b-icon icon="trash-fill" aria-hidden="true"></b-icon>
                        </b-button>
                    </td>
                </tr>
            </tbody>
        </table>

    </div>
</template>

<script>

export default {
    name: "TeilnehmerInnenListe",
    data() {
        return {
            modalShow: false,
            teilnehmerInnen: {
                name: '',
                eMail: '',
                adresse: '',
                telnum: '',
                startdatum: '',
                enddatum: '',
                gruppeId: ''
            },
            editTeilnehmerInnen: {
                name: '',
                eMail: '',
                adresse: '',
                telnum: '',
                startdatum: '',
                enddatum: '',
                gruppeId: '',
                id: ''
            }
        }
    },
    computed: {
        teilnehmerIn() {
            return this.$store.state.teilnehmerIn;
        },
        gruppen() {
            return this.$store.state.gruppen;
        }
    },
    methods:
    {
        deleteTeilnehmerIn(id) {
            this.$store.dispatch('deleteTeilnehmerIn', id)
        },

        postTeilnehmerIn() {
            this.$store.dispatch('postTeilnehmerIn', this.teilnehmerInnen)
            this.hideModal2()
        },

        putTeilnehmerIn() {
            this.$store.dispatch('putTeilnehmerIn', this.editTeilnehmerInnen)
            this.hideModal3()
        },
        async editTeilnehmerIn(teilnehmer) {
            this.editTeilnehmerInnen.name = teilnehmer.name,
            this.editTeilnehmerInnen.eMail = teilnehmer.eMail,
            this.editTeilnehmerInnen.adresse = teilnehmer.adresse;
            this.editTeilnehmerInnen.telnum = teilnehmer.telnum;
            this.editTeilnehmerInnen.startdatum = teilnehmer.startdatum;
            this.editTeilnehmerInnen.enddatum = teilnehmer.enddatum;
            this.editTeilnehmerInnen.gruppeId = teilnehmer.gruppeId;
            this.editTeilnehmerInnen.id = teilnehmer.id;
        },
        resetModal1() {
            this.teilnehmerInnen.name = ''
            this.teilnehmerInnen.eMail = ''
            this.teilnehmerInnen.adresse = ''
            this.teilnehmerInnen.telnum = ''
            this.teilnehmerInnen.startdatum = ''
            this.teilnehmerInnen.enddatum = ''
            this.teilnehmerInnen.gruppeId = ''
        },

        showModal2() {
            this.$refs['my-modal2'].show()
        },
        showModal3() {
            this.$refs['my-modal3'].show()
        },
        hideModal2() {
            this.$refs['my-modal2'].hide()
        },
        hideModal3() {
            this.$refs['my-modal3'].hide()
        },

    },
    mounted() {
        this.$store.dispatch('getAlleTeilnehmerInnen');
        this.$store.dispatch('getAlleGruppen');
    }
}

</script>


